<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version
 * @author Federico Tarantini federicot@gmail.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

/**
 * Purge old db entries cronjob
 */

require_once("system/Cronjob.php");
require_once('core/ActivityLog.php');
require_once('core/DeletedProjectPeer.php');

class PurgeDeletedProjects extends Cronjob {
	public function __construct() {
		$this->jobname = basename(__FILE__);
		parent::__construct();
	}

	public function run() {
		$c = new Criteria();	
		$c->add(DeletedProjectPeer::ISDELETED, 0);	
		$deletedProjects = DeletedProjectPeer::doSelect($c);
		foreach ($deletedProjects as $deletedProject){
			$deletedProject->delete();
		}	
	}

}

$cronjob = new PurgeDeletedProjects();
$cronjob->run();
?>
