CREATE TABLE tag_entry (
    section character varying(20),
    ref_id integer,
    tag_name varchar(50),
    PRIMARY KEY (section,ref_id,tag_name)
);

CREATE INDEX tagentry_tagname_idx on tag_entry(tag_name);

ALTER TABLE TRACKER ADD COLUMN show_dependencies_tab BOOLEAN;
ALTER TABLE TRACKER ALTER COLUMN show_dependencies_tab SET DEFAULT TRUE;
ALTER TABLE TRACKER ADD COLUMN show_duplicates_tab BOOLEAN;
ALTER TABLE TRACKER ALTER COLUMN show_duplicates_tab SET DEFAULT TRUE;
ALTER TABLE TRACKER ADD COLUMN show_associations_tab BOOLEAN;
ALTER TABLE TRACKER ALTER COLUMN show_associations_tab SET DEFAULT TRUE;
ALTER TABLE TRACKER ADD COLUMN show_time_tracking_tab BOOLEAN;
ALTER TABLE TRACKER ALTER COLUMN show_time_tracking_tab SET DEFAULT TRUE;
ALTER TABLE TRACKER ADD COLUMN show_tags_tab BOOLEAN;
ALTER TABLE TRACKER ALTER COLUMN show_tags_tab SET DEFAULT TRUE;


UPDATE TRACKER SET show_dependencies_tab=true, show_duplicates_tab=true, 
   show_associations_tab=true, show_time_tracking_tab=true, show_tags_tab=true;

ALTER TABLE forum ADD COLUMN show_associations_tab BOOLEAN;
ALTER TABLE forum ALTER COLUMN show_associations_tab SET DEFAULT TRUE;
ALTER TABLE forum ADD COLUMN show_tags_tab BOOLEAN;
ALTER TABLE forum ALTER COLUMN show_tags_tab SET DEFAULT TRUE;

UPDATE FORUM SET show_associations_tab=true,  show_tags_tab=true;

ALTER TABLE wiki_project_setting ADD COLUMN wiki_type INTEGER;
ALTER TABLE wiki_project_setting ALTER COLUMN wiki_type SET DEFAULT 0;
ALTER TABLE wiki_project_setting ADD COLUMN show_associations_tab BOOLEAN;
ALTER TABLE wiki_project_setting ALTER COLUMN show_associations_tab SET DEFAULT TRUE;
ALTER TABLE wiki_project_setting ADD COLUMN show_tags_tab BOOLEAN;
ALTER TABLE wiki_project_setting ALTER COLUMN show_tags_tab SET DEFAULT TRUE;

UPDATE wiki_project_setting SET wiki_type=0, show_associations_tab=true, show_tags_tab=true;

CREATE TABLE frs_project_setting (
    project_id INT NOT NULL  REFERENCES project(project_id) ON DELETE CASCADE,
    show_associations_tab boolean default true,
    show_tags_tab boolean default true
);

CREATE TABLE docman_project_setting (
    project_id INT NOT NULL  REFERENCES project(project_id) ON DELETE CASCADE,
    show_associations_tab boolean default true,
    show_tags_tab boolean default true
);
