<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Role.php';
// (on-demand) include_once 'core/RolePeer.php';
 

// (on-demand) include_once 'core/UserProject.php';
// (on-demand) include_once 'core/UserProjectPeer.php';

include_once 'core/UserProjectRolePeer.php';

/**
 * Base class that represents a row from the 'user_project_role' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to UserProjectRole class. 
 * 
 * @package core 
 */
abstract class BaseUserProjectRole extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var UserProjectRolePeer
	 */
	protected static $peer;

	/**
	 * The value for the user_project_id field.
	 * @var int	  
	 */
	protected $user_project_id;	

	/**
	 * The value for the role_id field.
	 * @var int	  
	 */
	protected $role_id;	
  
	/**
	 * Get the UserProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getUserProjectId()
	{
		return $this->user_project_id;
	}


	/**
	 * Set the value of `user_project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setUserProjectId($v)
	{
		if ($this->user_project_id !== $v) {
			$this->user_project_id = $v;
			$this->modifiedColumns[] = UserProjectRolePeer::USER_PROJECT_ID;
		}
			
		if ($this->aUserProject !== null && $this->aUserProject->getUserProjectId() !== $v) {
			$this->aUserProject = null;
		}
			
	}

  
	/**
	 * Get the RoleId column value.
	 *  
	 * @return int	  
	 */
	public function getRoleId()
	{
		return $this->role_id;
	}


	/**
	 * Set the value of `role_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setRoleId($v)
	{
		if ($this->role_id !== $v) {
			$this->role_id = $v;
			$this->modifiedColumns[] = UserProjectRolePeer::ROLE_ID;
		}
			
		if ($this->aRole !== null && $this->aRole->getRoleId() !== $v) {
			$this->aRole = null;
		}
			
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->user_project_id = $rs->getInt($startcol + 0);					
			$this->role_id = $rs->getInt($startcol + 1);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating UserProjectRole object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(UserProjectRolePeer::DATABASE_NAME);
		$criteria->add(UserProjectRolePeer::USER_PROJECT_ID, $this->user_project_id);
		$criteria->add(UserProjectRolePeer::ROLE_ID, $this->role_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(UserProjectRolePeer::DATABASE_NAME);
		if ($this->isColumnModified(UserProjectRolePeer::USER_PROJECT_ID)) $criteria->add(UserProjectRolePeer::USER_PROJECT_ID, $this->user_project_id);
		if ($this->isColumnModified(UserProjectRolePeer::ROLE_ID)) $criteria->add(UserProjectRolePeer::ROLE_ID, $this->role_id);
		return $criteria;			
	}
	
	

	/**
	 * @var Role	  
	 */
	protected $aRole;

	/**
	 * Declares an association between this object and a Role object
	 *
	 * @param Role $v
	 * @return void
	 * @throws PropelException
	 */
	public function setRole($v)
	{
			
		if ($v === null) {
			$this->setRoleId(NULL);
		} else {
			$this->setRoleId($v->getRoleId());
		}
   
		$this->aRole = $v;
	}


	/**
	 * Get the associated Role object
	 *
	 * @param Connection Optional Connection object.
	 * @return Role The associated Role object.
	 * @throws PropelException
	 */
	public function getRole($con = null)
	{
		// include the Peer class
		include_once 'core/RolePeer.php';

		if ($this->aRole === null && ($this->role_id !== null)) {
	
			$this->aRole = RolePeer::retrieveByPK($this->role_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = RolePeer::retrieveByPK($this->role_id, $con);
			   $obj->addUserProjectRoles($this);
			 */
		}
		return $this->aRole;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setRoleKey($key)
	{

		$this->setRoleId( (int) $key);			
		
	}

	/**
	 * @var UserProject	  
	 */
	protected $aUserProject;

	/**
	 * Declares an association between this object and a UserProject object
	 *
	 * @param UserProject $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUserProject($v)
	{
			
		if ($v === null) {
			$this->setUserProjectId(NULL);
		} else {
			$this->setUserProjectId($v->getUserProjectId());
		}
   
		$this->aUserProject = $v;
	}


	/**
	 * Get the associated UserProject object
	 *
	 * @param Connection Optional Connection object.
	 * @return UserProject The associated UserProject object.
	 * @throws PropelException
	 */
	public function getUserProject($con = null)
	{
		// include the Peer class
		include_once 'core/UserProjectPeer.php';

		if ($this->aUserProject === null && ($this->user_project_id !== null)) {
	
			$this->aUserProject = UserProjectPeer::retrieveByPK($this->user_project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserProjectPeer::retrieveByPK($this->user_project_id, $con);
			   $obj->addUserProjectRoles($this);
			 */
		}
		return $this->aUserProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserProjectKey($key)
	{

		$this->setUserProjectId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("user_project_id", "role_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case UserProjectRolePeer::USER_PROJECT_ID:
				return $this->getUserProjectId();
				break;
		  
			case UserProjectRolePeer::ROLE_ID:
				return $this->getRoleId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getUserProjectId();
				break;
  
			case 1:
				return $this->getRoleId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(UserProjectRolePeer::USER_PROJECT_ID, $arr)) $this->setUserProjectId($arr[UserProjectRolePeer::USER_PROJECT_ID]);
  
		if (array_key_exists(UserProjectRolePeer::ROLE_ID, $arr)) $this->setRoleId($arr[UserProjectRolePeer::ROLE_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case UserProjectRolePeer::USER_PROJECT_ID:
				$this->setUserProjectId($value);
				break;
	  
			case UserProjectRolePeer::ROLE_ID:
				$this->setRoleId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setUserProjectId($value);
				break;
  
			case 1:
				$this->setRoleId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(UserProjectRolePeer::DATABASE_NAME);

		try {
			$con->begin();
			UserProjectRolePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(UserProjectRolePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aRole !== null) {
				if ($this->aRole->isModified()) $this->aRole->save($con);
				$this->setRole($this->aRole);
			}
 
			if ($this->aUserProject !== null) {
				if ($this->aUserProject->isModified()) $this->aUserProject->save($con);
				$this->setUserProject($this->aUserProject);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UserProjectRolePeer::doInsert($this, $con);
					$this->setNew(false);
				} else {
					UserProjectRolePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return UserProjectRolePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aRole !== null) {
				if (($retval = $this->aRole->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUserProject !== null) {
				if (($retval = $this->aUserProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = UserProjectRolePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  


	private $pks = array();
	
	/**
	 * Set the PrimaryKey.
	 *
	 * @param array $keys The elements of the composite key (order must match the order in XML file).
	 * @return void
	 * @throws PropelException
	 */
	public function setPrimaryKey($keys)
	{						

		$this->setUserProjectId($keys[0]);

		$this->setRoleId($keys[1]);

	}


	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return array 
	 */
	public function getPrimaryKey()
	{
		$this->pks[0] = $this->getUserProjectId();
		$this->pks[1] = $this->getRoleId();
		return $this->pks;

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return UserProjectRole Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new UserProjectRole();
		
		$copyObj->setNew(true);
		
		$copyObj->setUserProjectId(NULL); // this is a pkey column, so set to default value
		$copyObj->setRoleId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return UserProjectRolePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UserProjectRolePeer();
		}
		return self::$peer;
	}

}
