<?php

/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Prez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/exceptions/PermissionDeniedException.php');

$project = GFUrl::getUrl()->getProject();

$id = $_REQUEST['id'];
$file = DocmanFilePeer::retrieveByPK($id);
if (!is_object($file) || $file->getDocmanFolder()->getProject()->getProjectId() != $project->getProjectId()) {
	throw new PermissionDeniedException();
}
$file->setIsLocked( Validator::sanitizeBool((isset($_POST['is_locked']) ? true : false)) );
$file->setDescription( Validator::sanitizeString($_POST['description']) );
$file->setDocmanFolderId( Validator::sanitizeInt($_POST['folder_id']) );

try {
	$file->save();
	GFUrl::redirect(GFUrl::getUrl()->projectURL($project,'','docman','admin'),array('subdir'=>$file->getDocmanFolder()->getDocmanFolderId(),'feedback'=>'Successfully Edited'));
} catch (InvalidDataException $ex) {
	$errors = $ex->getErrors();	       // attach object errors to validation errors
	$feedback = '* '.implode('<br />* ', $errors);
	include('DocmanFileEdit.php');
}

?>
