<?php

/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/docman/lib/html/DocmanAdminTemplate.php');
require_once('plugins/docman/lib/InfoParser.php');
require_once('plugins/docman/lib/DocmanTreeRenderer.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('plugins/docman/lib/DocmanFolder.php');

$theme = new DocmanAdminTemplate();

$project=GFUrl::getUrl()->getProject();
$params = array(
		'project' => $project,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Docman.BrowsePageTitle')
		);
$theme->header($params);

echo '<p><div class="infobox">'.$Lang->getText('Docman.DocmanAdminDescription').'</div></p>';

echo '<script type="text/javascript" src="/prototype.js"></script>';
echo '<script type="text/javascript" src="/scriptaculous.js"></script>';


$parser = new InfoParser($project);
$nested_folders = $parser->getNestedFolders();
$arranged_folders = $parser->getArrangedFolders();

$doctreerenderer = new DocmanTreeRenderer($project, $nested_folders, $arranged_folders);

if (isset($_REQUEST['subdir'])) {
	$subdir=Validator::sanitizeInt($_REQUEST['subdir']);
} else {
	$subdir=0;
}

/*$DocmanFolder = DocmanFolderPeer::retrieveByPk($subdir);
if (is_object($DocmanFolder)) {
	if ($DocmanFolder->userCanCreate()) {
		$button_state = true;
	} else {
		$button_state = false;
	}
} else {
	$button_state = false;
}*/
$button_state = true;

$nested_docs = $parser->getDocs($subdir);

$count=0;
if ($nested_docs->getRecordCount()>0) {
	$count=$nested_docs->getRecordCount();
}
if (isset($nested_folders[$subdir])) {
	$count += count($nested_folders[$subdir]);
}
$theader=array();
$theader[]=Language::getSessText('Docman.Navigation');
//$theader[]=Language::getSessText('Docman.Type');
$theader[]=Language::getSessText('Docman.FileName');
if($subdir != 0){
    $theader[]=Language::getSessText('Docman.Locked');
}
$theader[]=Language::getSessText('Docman.Edit');
$theader[]=Language::getSessText('Docman.Delete');

echo "<form id='updateFrm' action='".GFUrl::getURL()->currentBaseUrl('DocmanFoldersUpdate',array('parent_folder_id'=>$subdir))."' method='POST'>\n";
echo "<input type='hidden' name='subdir' value='{$subdir}' />\n";

echo $theme->tableTop($theader);
if ($count > 0) {
	$row=0;
	$mods=array('rowspan="'.($count).'"');
	if (isset($nested_folders[$subdir])) {
		foreach ($nested_folders[$subdir] as $doc) {
			$trow=array();
			if ($row==0) {
				$trow[]=$doctreerenderer->renderNavigation($subdir, true);
			}
			$row++;
//			$trow[] = 'directory';
			$trow[] = '<img src="/images/docman_folder.gif" height="16" width="16" border="0"> <a href="'.GFUrl::getURL()->currentBaseUrl('',array('subdir'=>$doc->getId())).'">'.$doc->getName().'</a>';
			if($subdir != 0){
			    $trow[] = '';
			}
			$trow[] = '<a href="'.GFUrl::getURL()->currentBaseUrl('DocmanFolderEdit',array('id'=>$doc->getId())).'">'.Language::getSessText('Docman.EditFolder').'</a>';
			$trow[] = '<a href="'.GFUrl::getURL()->currentBaseUrl('DocmanFolderDelete',array('id'=>$doc->getId())).'">'.Language::getSessText('Docman.DeleteFolder').'</a>';
			echo $theme->tableRow($trow,$mods,true);
			$mods=array();
			unset($trow);
		}
	}
	if ($nested_docs->getRecordCount()>0) {
		while ($nested_docs->next()) {
			$trow=array();
			if ($row==0) {
				$trow[]=$doctreerenderer->renderNavigation($subdir, true);
			}
			$row++;
//			$trow[] = 'file';
			$url = GFUrl::getURL()->downloadURL(DocmanFileVersion::SECTION,$nested_docs->getInt('docman_file_version_id'),$nested_docs->getInt('filesystem_id'),$nested_docs->getString('file_name_safe'));
			$trow[] = '<img src="/images/docman_doc.gif" height="16" width="16" border="0"><a href="'.$url.'"> '.$nested_docs->getString('file_name_safe').'</a>';
			$trow[] = (( $nested_docs->getBoolean('is_locked') ) ? '&nbsp;<img alt="(locked)" src="/images/locked.png">' : '&nbsp;' );
			$trow[] = '<a href="'.GFUrl::getURL()->currentBaseUrl('DocmanFileEdit',array('id'=>$nested_docs->getInt('docman_file_id'),'return_to' => 'admin')).'">'.Language::getSessText('Docman.EditFile').'</a>';
			$trow[] = '<a href="'.GFUrl::getURL()->currentBaseUrl('DocmanFileDelete',array('id'=>$nested_docs->getInt('docman_file_id'),'parent'=>$nested_docs->getInt('docman_folder_id'))).'">'.Language::getSessText('Docman.DeleteFile').'</a>';
			echo $theme->tableRow($trow,$mods,true);
			$mods=array();
		}
	}
} else {
	$trow[] = $doctreerenderer->renderNavigation($subdir, true);
	$trow[] = Language::getSessText('Docman.NoneFound');
	echo $theme->tableRow($trow,array('rowspan = 1','colspan = 5'),true);
}

//can only add files if you are in a subdir
echo $theme->tableBottom(
	array(
		"javascript:doSubmit('updateFrm');"=>Language::getSessText('Docman.UpdateFolders'),
		GFUrl::getURL()->projectURL($project,'DocmanFileAdd','docman','',array('subdir'=>$subdir,'redirect_to'=>'admin'))=>Language::getSessText('Docman.AddNew'),
		GFUrl::getURL()->currentBaseUrl('DocmanFolderAdd',array('parent_folder_id'=>$subdir))=>Language::getSessText('Docman.AddNewDir')
		),
	array(true,	$button_state, $button_state)
	);

echo "</form>\n";

$rs = DocmanFilePeer::doSelectPendingDocsRS($project->getProjectId());

$theader = array();
$theader[] = 'Filename';
$theader[] = 'Edit';
$theader[] = 'Delete';
$theader[] = 'Version #';
$theader[] = 'Changes';
$theader[] = 'Date';
$theader[] = 'Author';

echo '<p><h3>Pending Docs</h3></p>';

echo $theme->tableTop($theader);

if ($rs->getRecordCount() < 1) {
	echo $theme->tableFullRow('No Pending Docs');
}
while ($rs->next()) {
				$file = DocmanFilePeer::retrieveByPK($rs->getInt('docman_file_id'));
				$versions = sizeof($file->getDocmanFileVersions());

        $trow = array();
				$url = GFUrl::getURL()->downloadURL(DocmanFileVersion::SECTION,$rs->getInt('docman_file_version_id'),$rs->getInt('filesystem_id'),$rs->getString('file_name_safe'));
				$trow[] = '<a href="'.$url.'"><img src="/images/docman_doc.gif" height="16" width="16" border="0">&nbsp;'.$rs->getString('file_name_safe').'</a>';	
        $url = GFUrl::getURL()->projectURL($project,'DocmanFileEdit','docman','admin',array('id'=>$rs->getInt('docman_file_id')));
        $trow[] = '<a href="'.$url.'">'.Language::getSessText('Edit').'</a>';   
				if ($versions > 1) {
					$trow[] = '<a href="'.GFUrl::getURL()->projectUrl($project,'DocmanFileVersionDelete','docman','admin',array('docman_file_version_id'=>$rs->getInt('docman_file_version_id'))).'">'.$Lang->getText('Docman.DeleteFileVersion').'</a>';
				} else {
					$trow[] = '<a href="'.GFUrl::getURL()->projectUrl($project,'DocmanFileDelete','docman','admin',array('id'=>$rs->getInt('docman_file_id'))).'">'.$Lang->getText('Docman.DeleteFile').'</a>';
				}
        $trow[] = $rs->getInt('version_number');
        $trow[] = $rs->getString('changes');
        $trow[] = $rs->getDate('create_date');
        $trow[] = UserPeer::retrieveByPk($rs->getInt('created_by'))->getUserLink();
        echo $theme->tableRow($trow,array(),true);
}

echo $theme->tableBottom();
?>

<script type="text/javascript">
var jsBlockLink = false;
function doUnblockLink() { jsBlockLink = false; }
function doBlockLink() { jsBlockLink = true; }

function linkWatch(url) {
	if (jsBlockLink) jsBlockLink = false;
	else document.location.href = url;
}

function doSubmit(objId) {
	obj = FindObject(objId);
	obj.submit();
}

function verifyParent(element) {
	var parent_id;
	var tag;
	var child;
	var id;
	var i;
	
	if(element.tagName=='UL') {
		parent_id = element.id.substring(14); //Remove the jsDocmanParent
		//alert('UL Parent ' + parent_id);
		var found = false;
		for (i=0;i<element.childNodes.length;i++)
		{
			child = element.childNodes[i];
			tag = child.tagName;
			if(tag=='LI') {
				id = child.id.split('_')[1];
				//alert ('Verify ' + id + ' from parent ' + parent_id + ' childs: ' + child.childNodes.length)
				if (id != parent_id && id != null) {
					if(parentArr[id] != parent_id) {
						found = true;
						break;
					}
					//alert('Checking up ' + id + 'children')
					verifyParent(child);
					//alert('Finished checkin up ' + id)
				}
			}
		}
		if (found) {
			parentArr[id] = parent_id;
			var newPID = 'newParent['+id+']';
			newelem = document.getElementById(newPID);
			if (newelem != null) {
				newelem.value = parent_id;
			}
			else {
				for (i=0;i<child.childNodes.length;i++) {
					input_elem = child.childNodes[i];
					if(input_elem.tagName=='INPUT') {
						var form = input_elem.form
						newelem = document.createElement("input");
						newelem.setAttribute("type", "hidden");
						newelem.setAttribute("name", newPID );
						newelem.setAttribute("id", newPID );
						newelem.value = parent_id
						form.appendChild(newelem);
						break;
					}
				}
			}
		}
	}
	else if(element.tagName=='LI') {
		//alert('LI Parent ' + element.id);
		for (i=0;i<element.childNodes.length;i++)
		{
			child = element.childNodes[i];
			tag = child.tagName;
			if(tag=='UL') {
				verifyParent(child);
			}			
		}
	}
}

function updateOrder(element) {
	jsBlockLink = true;
	arrFolder = Sortable.serialize(element.id).split('&');
	for (i=0;i<arrFolder.length;i++) {
		folderKeyVal = arrFolder[i].split('=');
		obj = FindObject('FolderId'+folderKeyVal[1]);
		if (obj) obj.value = i;
	}
	
	verifyParent(element);
	
	return true;
}

parentArr = [];
<?php

foreach($parser->getElements() as $element) {
	print 'parentArr['.$element->getDocmanFolderId() . ']=' . $element->getParentFolderId() . ";\n";
}


$sortables_id = $doctreerenderer->getSortables();
/*foreach ($sortables_id as $sortable_id) {
	//echo 'Sortable.create("jsDocmanParent'.$sortable_id.'", {dropOnEmpty:true,containment:["jsDocmanParent'.$sortable_id.'"],tag:"li",constraint:false,onUpdate:updateOrder});'."\n";
	echo 'Sortable.create("jsDocmanParent'.$sortable_id.'", {dropOnEmpty:true,tag:"li",constraint:false,onUpdate:updateOrder});'."\n";
}*/
echo 'Sortable.create("jsDocmanParent0", {dropOnEmpty:true,tree:true,constraint:false,onUpdate:updateOrder});'."\n";
?>

function updateInitOrder() {
<?php
/*
foreach ($sortables_id as $sortable_id) {
	/*echo "\tobj = FindObject('jsDocmanParent{$sortable_id}');\n";
	echo "\tupdateOrder(obj);\n";
}*/
?>



oldload();convertTrees();window.setTimeout('expandableExpandItem()',100);docmanExpandTree();
}

window.onload=updateInitOrder;
</script>

<?php
$theme->footer($params);
?>
