<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-13
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

include ("lib/external/jpgraph/jpgraph.php");
include ("lib/external/jpgraph/jpgraph_line.php");

$session = Session::getSession();
$Lang = $session->getLanguage();

$Project = GFUrl::getUrl()->getProject();
$project_id = $Project->getProjectId();

$con = Propel::getConnection(FrsPackagePeer::DATABASE_NAME);
$stmt = $con->createStatement();

// Check if we want to filter by package
$package = (isset($_GET['frs_package_id']) ? Validator::sanitizeInt($_GET['frs_package_id']) : 0);
$begin = Validator::sanitizeDate($_GET['start_date']);
$end = Validator::sanitizeDate($_GET['end_date']);
$start = date('Y-m-d', (strtotime($end)-1.5*365*60*60*24));
$subprojects = ((isset($_REQUEST['subprojects'])) ? Validator::sanitizeInt($_REQUEST['subprojects']) : 0 );

$sqltime = "AND fsd.download_date BETWEEN '$start' AND '$end'";

// If there's a valid project_id, we'll filter by project all the queries
$all_ids = $Project->getAllSubprojectIds();
$all_ids[] = $project_id;
if ($package > 0) {
	$sqlaux = "AND frsp.frs_package_id = '$package' AND frsp.project_id IN (".implode(',',$all_ids).") ";
} else {
	if ($subprojects == 1) {
		$sqlaux = "AND frsp.project_id IN (".implode(',',$all_ids).") ";
	} else {
		$sqlaux = "AND frsp.project_id = $project_id ";
	}
}

$sql = "SELECT date_part('year', fsd.download_date)::text || '-' || date_part('month', fsd.download_date)::text AS month,
COUNT(*) as downloads
FROM filesystem_download fsd, filesystem fs, frs_release frsr, frs_package frsp
WHERE fsd.filesystem_id = fs.filesystem_id
AND fs.section = 'frsrelease'
AND fs.ref_id = frsr.frs_release_id
AND frsr.frs_package_id = frsp.frs_package_id
$sqltime
$sqlaux
GROUP BY month";

$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

//Build an array of the last 18 months in YYYY-MM format
$months=array();
$startdate=(strtotime($end)-1.5*365*60*60*24);
$addmonth=intval(date('m',$startdate));
$startyear=intval(date('Y',$startdate));
$addyear=0;
$months["".($startyear+$addyear).'-'.($addmonth).""]=0;
for ($i=0; $i<18; $i++) {
	$addmonth++;
	if ($addmonth > 12) {
		$addmonth=1;
		$addyear++;
	}
	$months["".($startyear+$addyear).'-'.($addmonth).""]=0;
}

$data=array();
$lastYear=0;
$i = -1;
if ($rs != null && $rs->getRecordCount() > 0) {
	while($rs->next()) {
		if (isset($months[$rs->getString('month')])) {
			$months[$rs->getString('month')] = $rs->getString('downloads');
		}
	}
}
// Create the graph. These two calls are always required
$graph = new Graph(400, 250);
$graph->title->Set($Lang->getText('FrsReporting.ByMonth'));
$graph->SetScale('textlin');
$graph->setBox(false);
$graph->setFrame(false);
$graph->img->SetMargin(40,20,30,50);
$graph->yaxis->scale->SetGrace(0);
$graph->yaxis->SetLabelMargin(1);
$graph->yaxis->SetTitle($Lang->getText('FrsReporting.Downloads'), 'low');
$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->yaxis->SetTitleMargin(30);
$graph->xaxis->SetTickLabels(array_keys($months));
$graph->xaxis->SetLabelAngle(90);

$lineplot = new LinePlot(array_values($months));
$lineplot->SetFillColor('#ADD8E6');
$graph->Add($lineplot);

$graph->Stroke();
?>
 
