<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists ScmModule
//

require_once('plugins/scm/lib/ScmModule.php');
require_once('plugins/scm/lib/ScmCommitFilter.php');
require_once('plugins/scm/lib/ScmCommitFilterProject.php');
require_once('plugins/scm/lib/ScmCommitFilter.php');
?>

<p><h3><?php echo $Lang->getText('ScmCommitFilter.Title'); ?></h3></p>
<form method="post" action="<?php echo GFUrl::getUrl()->currentBaseUrl('ScmCommitFilterProjectEditAction') ?>">
<?php
	$plugin = $project->getExclusiveTypePlugin('scm');
	$all_filters = ScmCommitFilterPeer::getFiltersForPlugin($plugin);
	$used_filters = ScmCommitFilterProjectPeer::getUsedFilterIds($project);
	
	$theader = array();
	$theader[] = $Lang->getText('ScmCommitFilter.UseFilter');
	$theader[] = $Lang->getText('ScmCommitFilter.FilterDescriptionName');
	$theader[] = $Lang->getText('ScmCommitFilter.FilterStringName');
	
	echo $theme->tableTop($theader);
	if (count($all_filters) == 0) {
		echo $theme->tableFullRow($Lang->getText('ScmCommitFilter.NoneFound'));
	} else {
		foreach ($all_filters as $filter) {
			$scm_commit_filter_id = $filter->getScmCommitFilterId();
			$uses_filter = in_array($scm_commit_filter_id, $used_filters);
			
			$trow = array();
			$trow[] = '<input type="checkbox" name="scm_commit_filters[]" value="'.$scm_commit_filter_id.'" '.($uses_filter ? 'checked="checked"' : '').'/>';
			$trow[] = $filter->getFilterDescription();
			$trow[] = $filter->getFilterString();
			echo $theme->tableRow($trow);
		}
	}
	echo $theme->tableBottom();
?>

<?php if (count($all_filters) > 0) : ?>
<div align="center">
<?php echo HTMLWidget::button("submit","" .   $Lang->getText('submit.edit')  . " ","submit","","")?>
</div>
<?php endif; ?>
</form>
