<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-13
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/html/HTMLWidget.php');
require_once('html/templates/ProjectReportingTemplate.php');

$session = Session::getSession();
$Project = GFUrl::getUrl()->getProject();
$project_id = $Project->getProjectId();
$Lang = $session->getLanguage();

$theme = new ProjectReportingTemplate();

$con = Propel::getConnection(TrackerPeer::DATABASE_NAME);

$users = array();
$users[0] = 'All';
foreach ($Project->getMembers() as $member) {
	$users[$member->getUserId()] = $member->getFullName();
}

$user_id=((isset($_REQUEST['user_id'])) ? Validator::sanitizeInt($_REQUEST['user_id']) : 0 );
$begin=((isset($_REQUEST['start_date'])) ? $_REQUEST['start_date'] : 0 );
$end=((isset($_REQUEST['end_date'])) ? $_REQUEST['end_date'] : 0 );
$subprojects=((isset($_REQUEST['subprojects'])) ? Validator::sanitizeInt($_REQUEST['subprojects']) : 0 );

if ($begin=='0') {
	$begin = (time()-(30*86400));
} else {
	$begin = strtotime($begin);
}
if ($end=='0') {
	$end = time();
} else {
	$end=strtotime($end)+86399;
}
if ($begin > $end) {
	$endtmp=$end;
	$end=$begin;
	$begin=$endtmp;
}

$params = array(
		'project' => $Project,
		'feedback' => (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TimeTrackingReporting.Title')
	);
$theme->header($params);

?>
<script language="javascript" type="text/javascript" src="/datetimepicker.js">
</script>
<br />
<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
<table border="0" cellspacing="0" cellpadding="3" bgcolor="#E0E0E0">
<tr>
	<td><strong><?php echo $Lang->getText('TimeTrackingReporting.FilterByUser') ?></strong></td>
	<td><?php echo HTMLWidget::selectBoxFromAssoc($users,'user_id',$user_id, false, false) ?></td>
	<td><input id="startdate" name="start_date" value="<?php echo date('M d Y',$begin); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('startdate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
	<td><input id="enddate" name="end_date" value="<?php echo date('M d Y',$end); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('enddate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
	<td valign="middle" rowspan="2"><?php echo HTMLWidget::button("submit","" .   $Lang->getText('Common.Submit')  . " ","submit","","")?></td>
</tr>
<tr>
	<td colspan="4">
		<strong><?php echo $Lang->getText('ProjectReporting.IncludeSubprojects') ?></strong> 
		<input type="checkbox" name="subprojects" value="1"<?php echo ($subprojects == 1) ? ' checked' : '';?>/>
	</td>
</tr>
</table>
</form>
<?php
$imgquerystring = '&amp;user_id='.$user_id.'&amp;start_date='.date('Y-m-d', $begin);
$imgquerystring .= '&amp;end_date='.date('Y-m-d', $end);
$imgquerystring .= '&amp;subprojects='.$subprojects;

echo '<br /><img src="/gf/project/'.$Project->getUnixName().'/tracker/graphs/?action=TimeByCategory'.$imgquerystring.'" height="250" width="400" alt="" /> &nbsp;';
echo '<img src="/gf/project/'.$Project->getUnixName().'/tracker/graphs/?action=TimeByItem'.$imgquerystring.'" height="250" width="400" alt="" />';
echo '<br /> &nbsp; <br /><img src="/gf/project/'.$Project->getUnixName().'/tracker/graphs/?action=TimeByUser'.$imgquerystring.'" height="250" width="400" alt="" /> &nbsp;';
echo '<img src="/gf/project/'.$Project->getUnixName().'/tracker/graphs/?action=TimeByMonth'.$imgquerystring.'" height="250" width="400" alt="" />';

echo '<br />';
echo '<br />';

// Get all Project Ids and Names
$all_ids = array();
$all_names = array();
if ($subprojects == 1) {
	$all_ids = $Project->getAllSubprojectIds();
	foreach ($Project->getAllSubprojects() as $subPrj) {
		$all_names[$subPrj->getProjectId()] = $subPrj->getProjectName();
	}
	$all_ids[] = $project_id;
	$all_names[$Project->getProjectId()] = $Project->getProjectName();
} else {
	$all_ids[] = $project_id;
}

// Check if we'll filter by user_id
if ($user_id > 0) {
	$sqluser = "AND tit.user_id = '$user_id'";
} else {
	$sqluser = '';
}

$sqltime = 'AND date_entry BETWEEN \''.date('Y-m-d', $begin).'\' AND \''.date('Y-m-d', $end).'\'';

/* *****************************
 * Total Hours Worked By User
 *******************************/

$sql = "SELECT u.user_id, SUM(tit.hours) as hours 
FROM tracker_item_time tit, \"user\" u, tracker_item ti, tracker t
WHERE tit.tracker_item_id = ti.tracker_item_id
AND tit.user_id = u.user_id
AND ti.tracker_id = t.tracker_id
AND t.project_id IN (".implode(',',$all_ids).") 
$sqltime
$sqluser
GROUP BY u.user_id ORDER BY hours DESC";

echo '<h3>'.$Lang->getText('TimeTrackingReporting.HoursWorkedByUser').'</h3>';
$theader = array('User', $Lang->getText('TimeTrackingReporting.HoursWorked'));
echo $theme->tableTop($theader);

$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

$itemscount = 0;
while($rs->next()) {
	$trow = array();

	$uid = $rs->getInt('user_id');
	$hours = $rs->getString('hours');

	if (!isset($users[$uid])) {
		$userObj = UserPeer::retrieveByPK($uid);
		$users[$uid] = $userObj->getFullName();
	}

	$trow[] = $users[$uid];
	$trow[] = $hours;

	echo $theme->tableRow($trow);
	unset($tmod);
	unset($trow);
	$itemscount++;

}

if ($itemscount==0) {
	echo $theme->tableFullRow($Lang->getText('TimeTrackingReporting.NoneFound'));
	echo $theme->tableBottom();
} else {
	echo $theme->tableBottom(array(GFUrl::getUrl()->currentBaseUrl('TimeTrackingExcel').$imgquerystring.'&amp;report=byUser'=>$Lang->getText('TimeTrackingReporting.ExportExcel')));
}
echo '<br /><br />';


/* *****************************
 * Total Hours Worked By Tracker
 *******************************/

$sql = "SELECT t.tracker_id, t.tracker_name, SUM(tit.hours) as hours, t.project_id 
FROM tracker_item_time tit, tracker_item ti, tracker t
WHERE tit.tracker_item_id = ti.tracker_item_id
AND ti.tracker_id = t.tracker_id
AND t.project_id IN (".implode(',',$all_ids).") 
$sqltime
$sqluser
GROUP BY t.project_id, t.tracker_id, t.tracker_name ORDER BY hours DESC";

echo '<h3>'.$Lang->getText('TimeTrackingReporting.HoursWorkedByTracker').'</h3>';

$theader = array($Lang->getText('SiteAdmin.Tracker'), $Lang->getText('TimeTrackingReporting.HoursWorked'));
echo $theme->tableTop($theader);

$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

$itemscount = 0;
while($rs->next()) {
	$trow = array();

	if ($subprojects == 1) {
		$trow[] = $all_names[$rs->getInt('project_id')] . ' &gt; ' . $rs->getString('tracker_name');
	} else {
		$trow[] = $rs->getString('tracker_name');
	}
	$trow[] = $rs->getString('hours');

	echo $theme->tableRow($trow);
	unset($tmod);
	unset($trow);
	$itemscount++;

}

if ($itemscount==0) {
	echo $theme->tableFullRow($Lang->getText('TimeTrackingReporting.NoneFound'));
	echo $theme->tableBottom();
} else {
	echo $theme->tableBottom(array(GFUrl::getUrl()->currentBaseUrl('TimeTrackingExcel').$imgquerystring.'&amp;report=byTracker'=>$Lang->getText('TimeTrackingReporting.ExportExcel')));
}
echo '<br /><br />';


/* *****************************
 * Hours Worked By User In Categories
 *******************************/

$sql = "SELECT u.user_id, ttc.tracker_time_code_id, ttc.time_name, SUM(tit.hours) as hours 
FROM tracker_item_time tit, \"user\" u, tracker_time_code ttc, tracker_item ti, tracker t
WHERE tit.tracker_item_id = ti.tracker_item_id
AND tit.user_id = u.user_id
AND tit.tracker_time_code_id = ttc.tracker_time_code_id
AND ti.tracker_id = t.tracker_id
AND t.project_id IN (".implode(',',$all_ids).") 
$sqltime
$sqluser
GROUP BY u.user_id, ttc.tracker_time_code_id, ttc.time_name
ORDER BY u.user_id, hours DESC";

echo '<h3>'.$Lang->getText('TimeTrackingReporting.HoursWorkedByUserCategory').'</h3>';
$theader = array('User', $Lang->getText('TrackerItemTime.TrackerTimeCodeIdName'), 
				$Lang->getText('TimeTrackingReporting.HoursWorked'));

echo $theme->tableTop($theader);

$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

$lastUser=0;
$itemscount = 0;

$rows = array();
$uids = array();

while($rs->next()) {
	$uid = $rs->getInt('user_id');

	if (!isset($uids[$uid])) {
		$uids[$uid] = 0;
	}
	if (!isset($users[$uid])) {
		$userObj = UserPeer::retrieveByPK($uid);
		$users[$uid] = $userObj->getFullName();
	}
	
	$uids[$uid]++;
	$rows[] = array('uid'=>$uid,'user_name'=>$users[$uid], 'time_name'=>$rs->getString('time_name'), 'hours'=>$rs->getString('hours'));

}

foreach ($rows as $row) {
	$tmod = array();
	$trow = array();
	
	if ($row['uid'] != $lastUser) {
		$tmod[]='rowspan="'.$uids[$row['uid']].'" bgcolor="#FFFFFF"';
		$lastUser = $row['uid'];
		$trow[] = $row['user_name'];
	}
	$tmod[] = '';
	$tmod[] = '';
	$trow[] = $row['time_name'];
	$trow[] = $row['hours'];
	echo $theme->tableRow($trow,$tmod);
	unset($tmod);
	unset($trow);

	$itemscount++;
}

if ($itemscount==0) {
	echo $theme->tableFullRow($Lang->getText('TimeTrackingReporting.NoneFound'));
	echo $theme->tableBottom();
} else {
	echo $theme->tableBottom(array(GFUrl::getUrl()->currentBaseUrl('TimeTrackingExcel').$imgquerystring.'&amp;report=inCategories'=>$Lang->getText('TimeTrackingReporting.ExportExcel')));
}
echo '<br /><br />';


/* *****************************
 * Hours Worked By User In Trackers
 *******************************/

$sql = "SELECT u.user_id, t.tracker_id, t.tracker_name, SUM(tit.hours) as hours, t.project_id
FROM tracker_item_time tit, \"user\" u, tracker_item ti, tracker t
WHERE tit.tracker_item_id = ti.tracker_item_id
AND tit.user_id = u.user_id
AND ti.tracker_id = t.tracker_id
AND t.project_id IN (".implode(',',$all_ids).") 
$sqltime
$sqluser
GROUP BY t.project_id, t.tracker_id, t.tracker_name, u.user_id
ORDER BY u.user_id, hours DESC";

echo '<h3>'.$Lang->getText('TimeTrackingReporting.HoursWorkedByUserTracker').'</h3>';
$theader = array('User', 'Tracker', $Lang->getText('TimeTrackingReporting.HoursWorked'));
echo $theme->tableTop($theader);

$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

$lastUser=0;
$itemscount = 0;

$rows = array();
$uids = array();

while($rs->next()) {
	$uid = $rs->getInt('user_id');
	$pid = $rs->getInt('project_id');

	if (!isset($uids[$uid])) {
		$uids[$uid] = 0;
	}
	if (!isset($users[$uid])) {
		$userObj = UserPeer::retrieveByPK($uid);
		$users[$uid] = $userObj->getFullName();
	}
	
	$uids[$uid]++;
	$rows[] = array('pid'=>$pid,'uid'=>$uid,'user_name'=>$users[$uid], 'tracker_name'=>$rs->getString('tracker_name'), 'hours'=>$rs->getString('hours'));

}

foreach ($rows as $row) {
	$tmod = array();
	$trow = array();
	
	if ($row['uid'] != $lastUser) {
		$tmod[]='rowspan="'.$uids[$row['uid']].'" bgcolor="#FFFFFF"';
		$lastUser = $row['uid'];
		$trow[] = $row['user_name'];
	}
	$tmod[] = '';
	$tmod[] = '';
	
	if ($subprojects == 1) {
		$trow[] = $all_names[$row['pid']] . ' &gt; ' . $row['tracker_name'];
	} else {
		$trow[] = $row['tracker_name'];
	}

	$trow[] = $row['hours'];
	echo $theme->tableRow($trow,$tmod);
	unset($tmod);
	unset($trow);

	$itemscount++;
}

if ($itemscount==0) {
	echo $theme->tableFullRow($Lang->getText('TimeTrackingReporting.NoneFound'));
	echo $theme->tableBottom();
} else {
	echo $theme->tableBottom(array(GFUrl::getUrl()->currentBaseUrl('TimeTrackingExcel').$imgquerystring.'&amp;report=inTrackers'=>$Lang->getText('TimeTrackingReporting.ExportExcel')));
}
echo '<br /><br />';


/* *****************************
 * Hours Worked By User In Tracker Items
 *******************************/

$sql = "SELECT u.user_id, t.tracker_id, t.tracker_name, ti.tracker_item_id, ti.summary, p.unix_name as project_unix_name, SUM(tit.hours) as hours, t.project_id 
FROM tracker_item_time tit, \"user\" u, tracker_item ti, tracker t, project p
WHERE tit.tracker_item_id = ti.tracker_item_id
AND tit.user_id = u.user_id
AND t.tracker_id = ti.tracker_id
AND t.project_id = p.project_id
AND t.project_id IN (".implode(',',$all_ids).")
$sqltime
$sqluser
GROUP BY t.project_id, p.unix_name, ti.tracker_item_id, u.user_id, t.tracker_id, t.tracker_name, ti.summary
ORDER BY u.user_id,  t.tracker_name, t.project_id, hours DESC";

echo '<h3>'.$Lang->getText('TimeTrackingReporting.HoursWorkedByUserItems').'</h3>';
$theader = array('User', 'Tracker', $Lang->getText('TimeTrackingReporting.TrackerItem'), $Lang->getText('TimeTrackingReporting.HoursWorked'));
echo $theme->tableTop($theader);

$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

$lastUser=0;
$lastTracker=0;
$itemscount = 0;

$rows = array();
$uids = array();
$tids = array();

while($rs->next()) {
	$uid = $rs->getInt('user_id');
	$tid = $rs->getInt('tracker_id');
	$pid = $rs->getInt('project_id');

	if (!isset($uids[$uid])) {
		$uids[$uid] = 0;
	}
	if (!isset($users[$uid])) {
		$userObj = UserPeer::retrieveByPK($uid);
		$users[$uid] = $userObj->getFullName();
	}
	
	if (!isset($tids[$tid])) {
		$tids[$tid] = array();
	}
	if (!isset($tids[$tid][$uid])) {
		$tids[$tid][$uid] = 0;
	}

	$uids[$uid]++;
	$tids[$tid][$uid]++;
	$rows[] = array('pid'=>$pid,'uid'=>$uid,'user_name'=>$users[$uid], 'tid'=>$tid, 'tracker_name'=>$rs->getString('tracker_name'), 'tracker_item_id'=>$rs->getString('tracker_item_id'), 'summary'=>$rs->getString('summary'), 'hours'=>$rs->getString('hours'), 'project_unix_name'=>$rs->getString('project_unix_name'));

}

foreach ($rows as $row) {
	$tmod = array();
	$trow = array();

	if ($row['uid'] != $lastUser) {
		$tmod[]='rowspan="'.$uids[$row['uid']].'" bgcolor="#FFFFFF"';
		$lastUser = $row['uid'];
		$lastTracker = 0;
		$trow[] = $row['user_name'];
	}
	if ($row['tid'] != $lastTracker) {
		$tmod[]='rowspan="'.$tids[$row['tid']][$row['uid']].'" bgcolor="#FFFFFF"';
		$lastTracker = $row['tid'];
		if ($subprojects == 1) {
			$trow[] = $all_names[$row['pid']] . ' &gt; ' . $row['tracker_name'];
		} else {
			$trow[] = $row['tracker_name'];
		}
	}

	$tmod[] = '';
	$tmod[] = '';
	//$trow[] =  '<a href="'.GFUrl::getUrl()->projectURL($Project, 'TrackerItemEdit','tracker', '', array('tracker_item_id' => $row['tracker_item_id'])).'">'.$row['summary'].'</a>';
	$trow[] =  '<a href="'.GFUrl::getUrl()->projectURL($row['project_unix_name'], 'TrackerItemEdit','tracker', '', array('tracker_item_id' => $row['tracker_item_id'])).'">'.$row['summary'].'</a>';
	$trow[] = $row['hours'];
	echo $theme->tableRow($trow,$tmod);
	unset($tmod);
	unset($trow);

	$itemscount++;
}

if ($itemscount==0) {
	echo $theme->tableFullRow($Lang->getText('TimeTrackingReporting.NoneFound'));
	echo $theme->tableBottom();
} else {
	echo $theme->tableBottom(array(GFUrl::getUrl()->currentBaseUrl('TimeTrackingExcel').$imgquerystring.'&amp;report=inItems'=>$Lang->getText('TimeTrackingReporting.ExportExcel')));
}
echo '<br /><br />';

$theme->footer();
?>
