<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists TrackerCannedResponse
//
require_once('plugins/tracker/lib/TrackerCannedResponsePeer.php');
require_once('plugins/tracker/lib/TrackerCannedResponse.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerAdminTemplate.php');
$theme = new TrackerAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$Tracker = TrackerPeer::retrieveByPk($_REQUEST['tracker_id']);

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TrackerCannedResponse.BrowsePageTitle')
		);
$theme->header($params);


// Retrieve the objects array
$crit = new Criteria();
$crit->add(TrackerCannedResponsePeer::TRACKER_ID, $Tracker->getTrackerId());
$arr = TrackerCannedResponsePeer::doSelect($crit);

if (count($arr) < 1) {
	echo '<span class="nonefound">'.$Lang->getText('TrackerCannedResponse.NoneFound').'</span>';
} else {

	$theader = array();

	$theader[] = $Lang->getText('TrackerCannedResponse.TitleName');
	$theader[] = $Lang->getText('Edit');
	$theader[] = $Lang->getText('Delete');

	echo $theme->tableTop($theader);

	foreach ($arr as $item) {
		$trow = array();
		$trow[]=$item->getTitle();
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerCannedResponseEdit').'&amp;tracker_id='.$item->getTracker()->getTrackerID() .'&amp;tracker_canned_response_id='.$item->getTrackerCannedResponseId().'">'. $Lang->getText('Edit') .'</a>';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerCannedResponseDelete').'&amp;tracker_id='.$item->getTracker()->getTrackerID() .'&amp;tracker_canned_response_id='.$item->getTrackerCannedResponseId().'">'. $Lang->getText('Delete') .'</a>';

		echo $theme->tableRow($trow);
	}

	echo $theme->tableBottom();

}

$theme->footer($params);
?>