<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/userfiles/lib/html/UserfilesMyTemplate.php');
require_once('lib/plugin/PluginResult.php');

class UserfilesMyAdminTemplate extends UserfilesMyTemplate {

	/**
	 * Header - this subclasses header and just passes params and data that is specific
	 * to this template
	 * @param array array of parameters
	 */
	function header($params) {
		$params['selectedbottomtab']='userfiles';
		$Lang = Session::getSession()->getLanguage();

		if(!isset($params['user']) || !is_object($params['user'])) {
			Throw new exception('Missing user object in userfiles template');
		} 
		if (!Session::getSession()->isLoggedIn()) {
			Throw new PermissionDeniedException();
		}		
		if(!($params['user']->getPrimaryKey() == Session::getSession()->getUser()->getPrimaryKey())) {
			Throw new PermissionDeniedException();
		}
		if (!isset($params['title'])) {
			Throw new exception('Missing title in userfiles template');
		}
		$params['title']=$Lang->getText('Tabs.Admin').' > '.$params['title'];

		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->userUrl($params['user'],'','userfiles/my','admin').'">'.$Lang->getText('Tabs.Admin').'</a>');
		
		return parent::header($params);
	}

	/**
	 *	getPluginNavElements - this overrides parent class and adds its own 
	 *	plugin listener
	 *	@return	PluginResultSet
	 */
	function getPluginNavElements($params) {
		$prs = parent::getPluginNavElements($params);
	       	$tprs = ActionManager::Notify('GET_USERFILES_NAV_ELEMENTS',$params);
		foreach ($tprs as $pr) {
			$prs->addResult($pr);
		}
		return $prs;
	}

}

?>
