<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'wiki_page' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.wiki.lib.map
 */
class UserWikiPageMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.userwiki.lib.map.UserWikiPageMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("wiki_page");
		$tMap->setPhpName("WikiPage");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("wiki_page_wiki_page_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("WIKI_PAGE_ID", "WikiPageId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("SECTION", "Section", "string", CreoleTypes::VARCHAR, true, 30);
		$tMap->addColumn("REF_ID", "RefId", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addColumn("PAGENAME", "Pagename", "string", CreoleTypes::VARCHAR, true, 50);
		$tMap->addColumn("FLAGS", "Flags", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("LATEST_VERSION", "LatestVersion", "int", CreoleTypes::INTEGER, true, null);
				
    }
}
