<?php
require_once('exceptions/PermissionDeniedException.php');
require_once('exceptions/InvalidDataException.php');
require_once('plugins/wiki/lib/WikiProjectSettingPeer.php');

	$project = GFUrl::getUrl()->getProject();
	$lang = Session::getSession()->getLanguage();
	
	if (!$project->getPermission()->isAdmin()) {
		throw new PermissionDeniedException();
	}

	if(isset($_REQUEST['wikiType'])){		
		$wikiSettings = WikiProjectSettingPeer::retrieveByPk($project->getProjectId());		
		if($_REQUEST['wikiType'] == 'text') {
			$wikiSettings->setWikiType(WikiProjectSetting::TEXT_WIKI);
		} else {
			$wikiSettings->setWikiType(WikiProjectSetting::HTML_WIKI);
		}
		
		$wikiSettings->save();
		$feedback = $lang->getText('Wiki.Admin.Saved');
	}
	
	GFUrl::redirect(GFUrl::getUrl()->projectURL($project,'','wiki','', array('action'=>'','feedback'=> $feedback)));
?>
