<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists Project
//
require_once('core/ProjectPeer.php');
require_once('core/Project.php');
require_once('html/HTMLWidget.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/templates/SiteAdminTemplate.php');
$theme = new SiteAdminTemplate();

//$Project = GFUrl::getUrl()->getProject();
//$Project = $ProjectPeer::retrieveByPk($_GET['id']);

$params = array(
	//	'project' => $Project,
	//	'SiteTemplate' => $SiteTemplate,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Project.Browse')
		);
$theme->header($params);


if (array_key_exists('project_name_search',$_REQUEST)) {
	$project_name_search = $_REQUEST['project_name_search'];
} else {
	$project_name_search = null;
}

$columns = array(
	ProjectPeer::PROJECT_ID => $Lang->getText('Project.ProjectIdName'),
	ProjectPeer::UNIX_NAME => $Lang->getText('Project.UnixNameName'),
	ProjectPeer::PROJECT_NAME => $Lang->getText('Project.ProjectNameName'),
	ProjectPeer::IS_PUBLIC => $Lang->getText('Project.IsPublicName'),
	ProjectPeer::STATUS => $Lang->getText('Project.StatusName'),
	ProjectPeer::IS_TEMPLATE => $Lang->getText('Project.IsTemplate'),
	$Lang->getText('Edit'),
	$Lang->getText('Delete')
);


// Retrieve the objects array
//$crit->add(UserPeer::, $Project->getProjectId());
if ($project_name_search) {
	// search by criteria
	$con = Propel::getConnection(ProjectPeer::DATABASE_NAME);
	$sql = 'select count(*) from project WHERE unix_name ILIKE ?';
	$stmt = $con->prepareStatement($sql);
	$stmt->setString(1, "$project_name_search%");
	$rs = $stmt->executeQuery(ResultSet::FETCHMODE_NUM);
	$rs->next();
	$total = $rs->getInt(1);
	
	$paginator = new Paginator('prjadmin', -1, $total, ProjectPeer::PROJECT_ID, $columns);
	$sql = 'select * from project WHERE unix_name ILIKE ? ' . $paginator->getSQL();
	$stmt = $con->prepareStatement($sql);
	$stmt->setString(1, "$project_name_search%");
	$rs = $stmt->executeQuery(ResultSet::FETCHMODE_NUM);
	$arr = ProjectPeer::populateObjects($rs);
} else {
	// all projects
	$crit = new Criteria();
	$total = ProjectPeer::doCount($crit);
	$paginator = new Paginator('prjadmin', -1, $total, ProjectPeer::PROJECT_ID, $columns);
	$paginator->addPageClauses($crit);
	//$crit->addAscendingOrderByColumn(ProjectPeer::PROJECT_ID);
	$arr = ProjectPeer::doSelect($crit);
}

$theader = $paginator->getSortableTableHeaders($theme);

//echo $paginator->showLimitOptions();

/*$theader = array();

$theader[] = $Lang->getText('Project.ProjectIdName');
$theader[] = $Lang->getText('Project.ProjectNameName');
$theader[] = $Lang->getText('Project.UnixNameName');
$theader[] = $Lang->getText('Project.IsPublicName');
$theader[] = $Lang->getText('Project.StatusName');
$theader[] = $Lang->getText('Project.IsTemplate');
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('Delete');*/

echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('Project.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();
		$trow[]=$item->getProjectId();
		$trow[]=$item->getUnixName();
		$trow[]='<a href="/gf/project/'.$item->getUnixName().'/">'.$item->getProjectName().'</a>';
		if ($item->getIsPublic()) {
			$trow[] = '';
		} else {
			$trow[] = Language::getSessText('Project.Private');
		}
		switch ($item->getStatus()) {
			case Project::STATUS_ACTIVE : $status = Language::getSessText('SiteAdmin.UserEdit.Active');break;
			case Project::STATUS_PENDING : $status = Language::getSessText('SiteAdmin.UserEdit.Pending');break;
			case Project::STATUS_HOLDING : $status = Language::getSessText('SiteAdmin.ProjectEdit.Holding');break;
		}	
		$trow[]=$status;
		if ($item->getIsTemplate()) {
			$trow[] = Language::getSessText('Common.Yes'); //express doesn't have templates .' - '.'<a href="'.GFUrl::getUrl()->currentBaseURL('ExportTplAction').'&amp;id='.$item->getID() .'">'.Language::getSessText('ProjectTemplate.LegacyExportText').'</a>';
			$deletelink = '';
		} else {
			$trow[] = '';
			$deletelink = '<a href="'. GFUrl::getUrl()->currentBaseUrl('ProjectDelete').'&amp;id='.$item->getID() .'">'. $Lang->getText('Delete') .'</a>';
		}
		if ($item->getStatus()==Project::STATUS_PENDING) {
			$trow[]='&nbsp;';
		} else {
			$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('ProjectEdit').'&amp;id='.$item->getID() .'">'. $Lang->getText('Edit') .'</a>';
		}
		$trow[]=$deletelink;

		echo $theme->tableRow($trow, array(), false);
	}
}
//echo $theme->listPaginatorRow($paginator);
$buttons_array = array();
$buttons_array[] = '<a href="'. GFUrl::getUrl()->baseURL('ProjectAdd','','register') .'">'. $Lang->getText('Project.AddNew') .'</a>';
$buttons_array[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('').'">'. $Lang->getText('Common.Back') .'</a>';
echo $theme->tableBottom($buttons_array, array(true, true));

if(isset($paginator) && is_object($paginator)) {
	echo '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
}

$theme->footer($params);

?>
