<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('core/SiteAdmin.php');
require_once('Validator.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}
if (!Session::getSession()->isSiteAdmin()) {
	throw new PermissionDeniedException();
}
$errors = array();
$Lang = Language::getSessLang();

try {
	$TroveCategory = new TroveCategory();
					
	$TroveCategory->setRootTroveCategoryId($_POST['root_trove_cat_id']);
	$TroveCategory->setParentTroveCategoryId($_POST['parent_trove_cat_id']);
	$TroveCategory->setAlias(Validator::sanitizeString($_POST['alias']));
	$TroveCategory->setCategoryName(Validator::sanitizeString($_POST['fullname']));
	$TroveCategory->setDescription(Validator::sanitizeString($_POST['description']));

	$TroveCategory->save();
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('DisplayTroveMap'), array('feedback' => $language->getText('TroveAdd.AddFeedback')));
} catch (InvalidDataException $ex) {
	$errors = array_merge($errors, $ex->getErrors());
	$feedback = '* '.implode('<br />* ', $errors);
	include('TroveAdd.php');
}

?>
