<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new Role and saves it to the 
// database
//
require_once('core/Role.php');
require_once('core/RolePeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$project = GFUrl::getUrl()->getProject();
if (!$project->userIsAdmin()) {
	// Only project admins can change member information
	throw new PermissionDeniedException();
}

$Lang = Language::getSessLang();

if (isset($_POST['sure'])) {
	$Role = RolePeer::retrieveByPk($_POST['role_id']);
	if (is_object($Role) && $Role->userCanDelete()) {
		$Role->delete();
		GFUrl::redirect($url->currentBaseURL('RoleBrowse'), array('feedback' => $Lang->getText('Role.DeleteFeedback')));
	} else {
		throw new PermissionDeniedError();
	}
} else {
	GFUrl::redirect($url->currentBaseURL('RoleBrowse'), array('feedback' => $Lang->getText('RoleDeleteForm.DidntConfirm')));
}

?>
